import 'package:flutter/material.dart';
import 'package:mobile_ui/mobile_ui.dart';
import 'package:mobile_ui/src/controls/spacing.dart';
import 'ui_spacing.dart';

class NoRecords extends StatelessWidget {
  final String? text;
  final Color? textColor;
  final Widget? svgPicture;
  final VoidCallback? onPressed;
  final CustomButtonStyle? buttonStyle;
  final String buttonText;
  final double paddingFlactor;
  final double rowSpacing;
  const NoRecords(
      {Key? key,
      this.text,
      this.svgPicture,
      this.onPressed,
      this.buttonText = 'Continue Exploring',
      this.buttonStyle,
      this.paddingFlactor = 1,
      this.rowSpacing = 1,
      this.textColor})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    final children = <Widget>[];
    if (svgPicture != null) {
      children.add(svgPicture!);
    }
    children.addAll([
      Spacing(
        rowSpacing,
      ),
      Label(
        text!,
        maxLines: 2,
        textAlign: TextAlign.center,
        color: textColor,
      ),
      Spacing(
        rowSpacing,
      )
    ]);
    if (onPressed != null) {
      children.add(Button(
        onPressed: onPressed,
        text: buttonText,
        buttonStyle: buttonStyle,
      ));
    }
    return Center(
      child: Container(
          alignment: Alignment.center,
          padding: EdgeInsets.all(uiSpacing(paddingFlactor)),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.start,
            children: children,
          )),
    );
  }
}
