import 'package:flutter/material.dart';
import 'package:mobile_ui/mobile_ui.dart';

class MobileUIContainer extends InheritedWidget {
  final UiConfig? uiConfig;
  const MobileUIContainer({Key? key, required Widget child, this.uiConfig})
      : super(key: key, child: child);

  static UiConfig? of(BuildContext context) {
    return context
        .dependOnInheritedWidgetOfExactType<MobileUIContainer>()
        ?.uiConfig;
  }

  @override
  bool updateShouldNotify(covariant MobileUIContainer oldWidget) {
    return uiConfig != oldWidget.uiConfig;
  }
}
