class Age {
  const Age(this.year, this.month, this.days);

  factory Age.fromDateTime(DateTime dob) {
    final now = DateTime.now();
    var y = now.year - dob.year;
    var m = now.month - dob.month;
    var d = now.day - dob.day;

    if (m < 0) {
      y = y - 1;
      m = 12 + m + (d < 0 ? 0 : 1);
    } else if (m == 0) {
      y = y - (d < 0 ? 1 : 0);
      m = d < 0 ? 11 : 0;
    } else {
      m = m - (d < 0 ? 1 : 0);
    }
    y = y < 0 ? 0 : y;
    m = m < 0 ? 0 : m;
    d = now.difference(dob).inDays;
    return Age(y, m, d);
  }

  final int year;
  final int month;
  final int days;

  static int calculateAge(DateTime dateOfBirth) {
    var today = DateTime.now();
    var age = today.year - dateOfBirth.year;
    var currentMonth = today.month;
    var birthdayMonth = dateOfBirth.month;

    if (birthdayMonth > currentMonth) {
      return age - 1;
    } else if (birthdayMonth == currentMonth) {
      var todayDate = today.day;
      var birthdayDate = dateOfBirth.day;
      if (todayDate > birthdayDate) return age - 1;
    }
    return age;
  }

  static bool isLegitAge(DateTime dateOfBirth) {
    return calculateAge(dateOfBirth) >= 18;
  }
}
