class Pager {
  int pageSize;
  int current;

  Pager({this.pageSize = 10, this.current = 1});

  Pager.fromJson(Map<String, dynamic> json)
      : pageSize = json["pageSize"]??10,
        current = json["current"]??1;
}

class PageList<T> extends Pager {
  List<T>? data;

  late int total;

  PageList({int pageSize = 10, int current = 1, this.data, this.total = 0})
      : super(pageSize: pageSize, current: current);

  PageList.fromJson(Map<String, dynamic> json,
      [T Function(Map<String, dynamic> map)? create]) {
    final pagination = json["pagination"];
    pageSize = pagination["pageSize"];
    current = pagination["current"];
    total = pagination["total"];

    if (json["data"] != null) {
      data = <T>[];
      var list = json["data"];
      if (list.length > 0) {
        list.forEach((m) {
          data!.add(create == null ? m : create(m));
        });
      }
    } else {
      data = [];
    }
  }
}
